/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: tagCLIPDATAPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the tagCLIPDATAPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=tagCLIPDATA.class)
public class tagCLIPDATAPointer extends StructurePointer {

	// NULL
	public static final tagCLIPDATAPointer NULL = new tagCLIPDATAPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected tagCLIPDATAPointer(long address) {
		super(address);
	}

	public static tagCLIPDATAPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static tagCLIPDATAPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static tagCLIPDATAPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new tagCLIPDATAPointer(address);
	}

	public tagCLIPDATAPointer add(long count) {
		return tagCLIPDATAPointer.cast(address + (tagCLIPDATA.SIZEOF * count));
	}

	public tagCLIPDATAPointer add(Scalar count) {
		return add(count.longValue());
	}

	public tagCLIPDATAPointer addOffset(long offset) {
		return tagCLIPDATAPointer.cast(address + offset);
	}

	public tagCLIPDATAPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public tagCLIPDATAPointer sub(long count) {
		return tagCLIPDATAPointer.cast(address - (tagCLIPDATA.SIZEOF * count));
	}

	public tagCLIPDATAPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public tagCLIPDATAPointer subOffset(long offset) {
		return tagCLIPDATAPointer.cast(address - offset);
	}

	public tagCLIPDATAPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public tagCLIPDATAPointer untag(long mask) {
		return tagCLIPDATAPointer.cast(address & ~mask);
	}

	public tagCLIPDATAPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return tagCLIPDATA.SIZEOF;
	}

	// Implementation methods

	// U32 cbSize
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_cbSizeOffset_", declaredType="U32")
	public UDATA cbSize() throws CorruptDataException {
		return new U32(getIntAtOffset(tagCLIPDATA._cbSizeOffset_));
	}

	// U32 cbSize
	public UDATAPointer cbSizeEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(tagCLIPDATA._cbSizeOffset_));
	}

	// U8* pClipData
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_pClipDataOffset_", declaredType="U8*")
	public U8Pointer pClipData() throws CorruptDataException {
		return U8Pointer.cast(getPointerAtOffset(tagCLIPDATA._pClipDataOffset_));
	}

	// U8* pClipData
	public PointerPointer pClipDataEA() throws CorruptDataException {
		return PointerPointer.cast(nonNullFieldEA(tagCLIPDATA._pClipDataOffset_));
	}

	// I32 ulClipFmt
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ulClipFmtOffset_", declaredType="I32")
	public IDATA ulClipFmt() throws CorruptDataException {
		return new I32(getIntAtOffset(tagCLIPDATA._ulClipFmtOffset_));
	}

	// I32 ulClipFmt
	public IDATAPointer ulClipFmtEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(tagCLIPDATA._ulClipFmtOffset_));
	}

}
